# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 rule27 rule28 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26,rule27,rule28 ]) => {
    return {
        $class: "org.accordproject.promissorynote.TemplateModel",
        
        dollarAmount : rule1,
        date : rule3,
        maker : rule5,
        interestRate : rule19,
        individual : rule7,
        makerAddress : rule9,
        lender : rule11,
        legalEntity : rule13,
        lenderAddress : rule15,
        principal : rule17,
        maturityDate : rule21,
        defaultDays : rule23,
        insolvencyDays : rule25,
        jurisdiction : rule27
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "PROMISSORY NOTE \n" 


rule1 -> Double {% id %} # dollarAmount 


rule2 -> " USD " 


rule3 -> DateTime {% id %} # date 


rule4 -> "\n\nFOR VALUE RECEIVED, the undersigned, " 


rule5 -> String {% id %} # maker 


rule6 -> ", an " 


rule7 -> "individual residing":? {% (d) => {return d[0] !== null;}%} # individual 


rule8 -> " at " 


rule9 -> String {% id %} # makerAddress 


rule10 -> " (“Maker”), hereby promises to pay to the order of " 


rule11 -> String {% id %} # lender 


rule12 -> ", a " 


rule13 -> LegalEntity {% id %} # legalEntity 


rule14 -> ", having offices at " 


rule15 -> String {% id %} # lenderAddress 


rule16 -> ", or its successors and permitted assigns	 (“Lender” or the “Company”), the principal sum of " 


rule17 -> Double {% id %} # principal 


rule18 -> " USD, plus any and all interest accrued thereon at the Note Rate (defined below), each due and payable in cash in lawful money of the United States on the dates and in the manner set forth in this Promissory Note (this “Note”). \n1. Interest. The principal amount of this Note shall bear interest at " 


rule19 -> Double {% id %} # interestRate 


rule20 -> "% per annum (the “Note Rate”). Interest shall be computed on the basis of a three hundred and sixty-five (365) day year and charged for the actual number of days elapsed. Interest shall accrue on the original principal balance only and there shall be no accrual of interest upon interest. \n2. Payment of Principal and Interest. The principal amount of this Note and the interest thereon shall be due and payable in full on the earlier of (a) " 


rule21 -> DateTime {% id %} # maturityDate 


rule22 -> " or (b) ten (10) days prior to the Company filing an S-1 registration statement with the U.S. Securities and Exchange Commission in contemplation of an initial public offering (“IPO”). As used herein, IPO means the closing of a firm commitment underwritten public offering pursuant to a registration statement under the Securities Act of 1933, as amended.\n4. Prepayment. The Maker may prepay any portion of the principal balance of this Note at any time without penalty. \n\n6. Default. Each of the following shall constitute an event of default (“Event of Default”) under this Note: \n(a) the Maker shall fail to pay when due (whether by acceleration or otherwise) principal or interest on this Note, and such default shall have continued for a period of " 


rule23 -> Integer {% id %} # defaultDays 


rule24 -> " days; \n(b) a proceeding (other than a proceeding commenced by the Maker) shall have been instituted in a court having jurisdiction seeking a decree or order for relief in respect of the Maker in an involuntary case under any applicable bankruptcy, insolvency or other similar law now or hereafter in effect, and such proceedings shall remain undismissed or unstayed and in effect for a period of " 


rule25 -> Integer {% id %} # insolvencyDays 


rule26 -> " days (so long as the Maker is diligently proceeding to effect such dismissal or stay) or such court shall enter a decree or order granting the relief sought in such proceeding; or\n(c) the Maker commences a voluntary case under any applicable bankruptcy, insolvency or other similar law now or hereafter in effect, consents to the entry of an order for relief in an involuntary case under any such law, or makes a general assignment for the benefit of creditors, or fails generally to pay his debts as they become due, or takes any action in furtherance of any of the foregoing.\n7. Remedies. Upon the occurrence of any Event of Default, the Lender may, without notice or demand to the Maker, exercise any or all of the following remedies: \n(a) declare all unpaid principal owing under this Note, together with all accrued and unpaid interest and other amounts owing hereunder, to be immediately due and payable without demand, protest, notice of protest, notice of default, presentment for payment or further notice of any kind; or \n(b) proceed to enforce such other and additional rights and remedies as the Lender may be provided by applicable law. \n \n9. Governing Law. This Note shall be governed by, and construed and enforced in accordance with, the internal laws (other than the choice of law principles thereof) of " 


rule27 -> String {% id %} # jurisdiction 


rule28 -> ". \n10. Waiver. No failure to exercise and no delay in exercising any right, power or privilege hereunder shall operate as a waiver thereof, nor shall any single or partial exercise of any right, power or privilege hereunder preclude any other or further exercise thereof or the exercise of any other right, power or privilege. The rights and remedies herein provided are cumulative and not exclusive of any rights or remedies provided by law. \n11. Savings Clause. Notwithstanding any provision contained in this Note, the Lender shall not be entitled to receive, collect or apply as interest on this Note any amount in excess of the highest lawful rate permissible under any law which a court of competent jurisdiction may deem applicable hereto. If the Lender ever receives, collects or applies as interest any such excess, the amount that would be excessive interest shall be deemed to be a partial payment of principal and treated hereunder as such, and, if the principal balance of this Note is paid in full, any remaining excess shall promptly be paid to the Maker. \n12. Amendment. This Note may be amended or modified only upon the written consent of both the Lender and the Maker. Any amendment must specifically state the provision or provisions to be amended and the manner in which such provision or provisions are to be amended. \n13. Entire Agreement. This Note constitutes the entire agreement of the Maker and the Lender with respect to the subject matter hereof and supersedes all other prior arrangements, understandings, statements, representations and warranties, expressed or implied, and no oral statements or prior written statements not contained in this Note shall have any force and effect. \n14. Counterparts. This Note may be executed in counterparts, each of which shall constitute an original and all of which shall constitute one and the same instrument. \n15. Assignment. This Note may not be assigned and/or transferred in whole or in part by the Maker without the prior written consent of the Lender, which consent shall be in the Lender’s sole and absolute discretion. This Note may be assigned and/or transferred in whole or in part by the Lender at any time. The obligations of the Maker hereunder shall bind his heirs and permitted assigns, and all rights, benefits and privileges conferred on the Lender by this Note shall be and hereby are extended to, conferred upon, and may be enforced by, the successors and assigns of the Lender. \n\nIN WITNESS WHEREOF, the Maker has executed this Note as of the date and year first above written. \n \n		\n 		\n\n" 


ContractState -> String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractState",
        stateId : data[0],
        contract : data[2]
    };
}
%}


ContractModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ContractModel",
        contractId : data[0]
    };
}
%}


ClauseModel -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ClauseModel",
        clauseId : data[0]
    };
}
%}


Request -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Request",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Response -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Response",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


ErrorResponse -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.ErrorResponse",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


Payload -> ContractModel  __  Request  __  ContractState 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  ContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.common.Failure",
        error : data[0]
    };
}
%}


Request -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.promissorynote.Request",
        amountPaid : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


Response -> Double  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.promissorynote.Response",
        outstandingBalance : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


LegalEntity -> "PLC" {% id %} | "LLC" {% id %} | "INC" {% id %} | "Corporation" {% id %} 



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}